import java.awt.*;
import javax.swing.*;
import alice.logictuple.*;
import alice.tucson.api.*;
import java.lang.*;
import alice.tuprolog.*;
import java.io.*;
import java.lang.Object.*;
import java.util.*;

public class Paladin extends alice.tucson.api.Agent { 

	//Inizializzo la variabile globale del "ritardo di passo"
	int time=1000;
	int posX1 = 16;
   	int posY1 = 3;
			
	//costruttore di default della classe Paladin
	public Paladin(AgentId aid) throws TucsonException {
   	super(aid);
	}//chiudo il costruttore di default
	
	//costruttore con inserimento della velocit (ritardo di passo) del Paladin
	public Paladin(AgentId aid, int delay) throws TucsonException {
   	super(aid);
   	this.time=delay;
	}//chiudo il costruttore
	
	//costruttore con inserimento della velocit (ritardo di passo) e della posizione iniziale del Paladin
	public Paladin(AgentId aid, int delay, int x, int y) throws TucsonException {
   	super(aid);
   	this.time=delay;
   	this.posX1=x;
   	this.posY1=y;
	}//chiudo il costruttore
	
	public void body(){
		try {
			//Apro un contesto Tucson tucson di Default
			TucsonContext dungeon = Tucson.enterDefaultContext();

			//TupleCenter usato come mappa per passare i parametri e lo chiamo Hell
			TupleCentreId hell = new TupleCentreId("hell");
			
			//TupleCenter usato per le posizioni e i combattimenti
			TupleCentreId arena = new TupleCentreId("arena");
			
			//Posizione iniziale
			Value goblinX1 = new Value(posX1);				
			Value goblinY1 = new Value(posY1);
			
			//Punti vita iniziali
			int lifepoints=200;
			Value lpG1 = new Value(lifepoints);
			
			//LogicTuple dimensioni=new LogicTuple("Dungeon", X, Y);    
			//LogicTuple porta = dungeon.in(hell, new LogicTuple ("Door", new alice.logictuple.Var("X2"), new alice.logictuple.Var("Y2") ));
			//System.out.println(porta);
			
			//Inizializzazione variabili
			int[][] map = new int[144][2];
			int A, B;
			int dead=0;
			int changedir=0;
			int out=0;
			
			//Direzione iniziale del mostro casuale
			Random r = new Random();
			int direction=r.nextInt(4);
			
			//Inizializza posizioni successive a quella iniziale
			LogicTuple pos = new LogicTuple("Paladin",goblinX1,goblinY1,lpG1);
			
			//Conoscenza del goblin della mappa
			for (int i=0; i<144; i++) {
				pos=dungeon.in(hell, new LogicTuple ("Wall", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y") ));
				A = pos.getArg(0).intValue();
				B = pos.getArg(1).intValue();
				map[i][0]= A;
				map[i][1]= B;
				Value A1 = new Value(A);				
				Value B1 = new Value(B);
				LogicTuple wall = new LogicTuple("Wall", A1, B1);
				dungeon.out(hell, wall);
				}
			
			//System.out.println("" +map[127][0] + map[127][1]);
			
			//out posizione iniziale e relativa stampa
			LogicTuple start = new LogicTuple("Paladin",goblinX1,goblinY1,lpG1);
			dungeon.out(arena, start);
			System.out.println("Paladin e' in posizione: (" +goblinX1 +"," +goblinY1 +"). I suoi lifepoints residui sono " +lpG1);
			
			//Movimento
			do {
				if (direction==0) { //incremento le X
					//inserisco una pausa per ogni movimento del Goblin
					Thread.sleep(time);
					
					//Inizializzo la variabile di cambio direzione
					changedir=0;
					
					//Leggo la posizione attuale dal Tuple Centre
					LogicTuple pos1 = new LogicTuple("Paladin", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					dungeon.rd(arena, pos1);
					int lp = pos1.getArg(2).intValue();
					
					//Incremento la coordinata X
					posX1=posX1+1;
					//posY1=posY1+1;
					
					//Controllo nella mappa se sono di fronte a un muro ed eventualmente cambio direzione in maniera random
					for (int j=0; j<144; j++) {
						if ((posX1==map[j][0] && posY1==map[j][1]) || (posX1>19) || (posY1>19)  || (posX1<0) || (posY1<0)) {
							//this.wait(500);
							System.out.print("Paladin ha un muro di fronte a se'. ");
							changedir=1;
							posX1=posX1-1;
							//cambia direzione
							do {
								direction=(r.nextInt(4));
								//System.out.println(direction);
							} while (direction<1);
							if (direction == 0) { System.out.println("Si dirige a Est.");}
							if (direction == 1) { System.out.println("Si dirige a Nord.");}
							if (direction == 2) { System.out.println("Si dirige a Ovest.");}
							if (direction == 3) { System.out.println("Si dirige a Sud.");}
						}	
						//pos1=dungeon.rdp(hell, new LogicTuple ("Wall", goblinX1, goblinY1 ));
					//for (int i=0; i<128; i++) {
					}
					
					//Aggiorno la posizione e i lifepoints del Goblin nell'arena
					goblinX1 = new Value(posX1);				
					goblinY1 = new Value(posY1);
					Value LPgoblin1 = new Value(lp);
					pos = new LogicTuple("Paladin",goblinX1,goblinY1,LPgoblin1);
					dungeon.out(arena, pos);
					//System.out.println("" + r.nextInt(3));
					
					//Stampo la posizione del Goblin nell'arena solo nel caso sia cambiata
					if (changedir==0 && lp>0) {
					System.out.println("Paladin e' in posizione: (" +goblinX1 +"," +goblinY1 +"). I suoi lifepoints residui sono " +LPgoblin1);
					}
					
					//Elimino la vecchia posizione dal centro di tuple
					dungeon.in(arena, pos1);
					
					Thread.sleep(50);
					
					//Leggo la posizione attuale degli altri personaggi
					//LogicTuple pos2 = new LogicTuple("Goblin_1", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					//LogicTuple pos1 = new LogicTuple("Goblin_1", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					//if (pos2==pos) {
						//System.out.println("Paladin e Goblin_1 sono in combattimento!");
						//}
					
					//Controllo che i lifepoints non siano 0 o inferiori, in tal caso il Goblin muore
					dungeon.rdp(arena, pos1);
					lp = pos1.getArg(2).intValue();
					//System.out.println(lp);
					if (lp<=0) {
						dead=1;
						dungeon.inp(arena, new LogicTuple ("Paladin", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z")));
						LogicTuple end = new LogicTuple("Paladin is dead",goblinX1,goblinY1,new Value(0));
						dungeon.out(arena, end);
						}
				}
				if (direction==1) { //incremento le Y
					//inserisco una pausa per ogni movimento del Goblin
					Thread.sleep(time);
					
					//Inizializzo la variabile di cambio direzione
					changedir=0;
					
					//Leggo la posizione attuale dal Tuple Centre
					LogicTuple pos1 = new LogicTuple("Paladin", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					dungeon.rd(arena, pos1);
					int lp = pos1.getArg(2).intValue();
					
					//Incremento la coordinata Y
					posY1=posY1+1;
					
					//Controllo nella mappa se sono di fronte a un muro ed eventualmente cambio direzione in maniera random
					for (int j=0; j<144; j++) {
						if ((posX1==map[j][0] && posY1==map[j][1]) || (posX1>19) || (posY1>19)  || (posX1<0) || (posY1<0)) {
							//this.wait(500);
							System.out.print("Paladin ha un muro di fronte a se'. ");
							changedir=1;
							posY1=posY1-1;
							//cambia direzione
							do {
								direction=(r.nextInt(4));
								//System.out.println(direction);
							} while (direction>0 && direction<2);
							if (direction == 0) { System.out.println("Si dirige a Est.");}
							if (direction == 1) { System.out.println("Si dirige a Nord.");}
							if (direction == 2) { System.out.println("Si dirige a Ovest.");}
							if (direction == 3) { System.out.println("Si dirige a Sud.");}
						}
					}
					
					//Aggiorno la posizione e i lifepoints del Goblin nell'arena
					goblinX1 = new Value(posX1);				
					goblinY1 = new Value(posY1);
					Value LPgoblin1 = new Value(lp);
					pos = new LogicTuple("Paladin",goblinX1,goblinY1,LPgoblin1);
					dungeon.out(arena, pos);
					
					//Stampo la posizione del Goblin nell'arena solo nel caso sia cambiata
					if (changedir==0 && lp>0) {
					System.out.println("Paladin e' in posizione: (" +goblinX1 +"," +goblinY1 +"). I suoi lifepoints residui sono " +LPgoblin1);
					}
					
					//Elimino la vecchia posizione dal centro di tuple
					dungeon.in(arena, pos1);
					
					Thread.sleep(50);
					
					//Leggo la posizione attuale degli altri personaggi
					//LogicTuple pos2 = new LogicTuple("Goblin_1", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					//LogicTuple pos1 = new LogicTuple("Goblin_1", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					//if (pos2==pos) {
						//System.out.println("Paladin e Goblin_1 sono in combattimento!");
						//}
					
					//Controllo che i lifepoints non siano 0 o inferiori, in tal caso il Goblin muore
					dungeon.rdp(arena, pos1);
					lp = pos1.getArg(2).intValue();
					//System.out.println(lp);
					if (lp<=0) {
						dead=1;
						dungeon.inp(arena, new LogicTuple ("Paladin", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z")));
						LogicTuple end = new LogicTuple("Paladin is dead",goblinX1,goblinY1,new Value(0));
						dungeon.out(arena, end);
						}
				}
				if (direction==2) { //decremento le X
					//inserisco una pausa per ogni movimento del Goblin
					Thread.sleep(time);
					
					//Inizializzo la variabile di cambio direzione
					changedir=0;
					
					//Leggo la posizione attuale dal Tuple Centre
					LogicTuple pos1 = new LogicTuple("Paladin", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					dungeon.rd(arena, pos1);
					int lp = pos1.getArg(2).intValue();
					//System.out.println(lp2);
					
					//Decremento la coordinata X
					posX1=posX1-1;
					//Controllo nella mappa se sono di fronte a un muro ed eventualmente cambio direzione in maniera random
					for (int j=0; j<144; j++) {
						if ((posX1==map[j][0] && posY1==map[j][1]) || (posX1>19) || (posY1>19)  || (posX1<0) || (posY1<0)) {
							//this.wait(500);
							System.out.print("Paladin ha un muro di fronte a se'. ");
							changedir=1;
							posX1=posX1+1;
							//cambia direzione
							do {
								direction=(r.nextInt(4));
								//System.out.println(direction);
							} while (direction>1 && direction<3);
							if (direction == 0) { System.out.println("Si dirige a Est.");}
							if (direction == 1) { System.out.println("Si dirige a Nord.");}
							if (direction == 2) { System.out.println("Si dirige a Ovest.");}
							if (direction == 3) { System.out.println("Si dirige a Sud.");}
						}
					}
					
					//Aggiorno la posizione e i lifepoints del Goblin nell'arena
					goblinX1 = new Value(posX1);				
					goblinY1 = new Value(posY1);
					Value LPgoblin1 = new Value(lp);
					pos = new LogicTuple("Paladin",goblinX1,goblinY1,LPgoblin1);
					dungeon.out(arena, pos);
					
					//Stampo la posizione del Goblin nell'arena solo nel caso sia cambiata
					if (changedir==0 && lp>0) {
					System.out.println("Paladin e' in posizione: (" +goblinX1 +"," +goblinY1 +"). I suoi lifepoints residui sono " +LPgoblin1);
					}
					
					//Elimino la vecchia posizione dal centro di tuple
					dungeon.in(arena, pos1);
					
					Thread.sleep(50);
					
					//Leggo la posizione attuale degli altri personaggi
					//LogicTuple pos2 = new LogicTuple("Goblin_1", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					//LogicTuple pos1 = new LogicTuple("Goblin_1", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					//if (pos2==pos) {
						//System.out.println("Paladin e Goblin_1 sono in combattimento!");
						//}
					
					//Controllo che i lifepoints non siano 0 o inferiori, in tal caso il Goblin muore
					dungeon.rdp(arena, pos1);
					lp = pos1.getArg(2).intValue();
					//System.out.println(lp);
					if (lp<=0) {
						dead=1;
						dungeon.inp(arena, new LogicTuple ("Paladin", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z")));
						LogicTuple end = new LogicTuple("Paladin is dead",goblinX1,goblinY1,new Value(0));
						dungeon.out(arena, end);
						}
				}
				if (direction==3) { //decremento le Y
					//inserisco una pausa per ogni movimento del Goblin
					Thread.sleep(time);
					
					//Inizializzo la variabile di cambio direzione
					changedir=0;
					
					//Leggo la posizione attuale dal Tuple Centre
					LogicTuple pos1 = new LogicTuple("Paladin", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					dungeon.rd(arena, pos1);
					int lp = pos1.getArg(2).intValue();
					//System.out.println(lp);
					
					//Decremento la coordinata Y
					posY1=posY1-1;
					
					//Controllo nella mappa se sono di fronte a un muro ed eventualmente cambio direzione in maniera random
					for (int j=0; j<144; j++) {
						if ((posX1==map[j][0] && posY1==map[j][1]) || (posX1>19) || (posY1>19) || (posX1<0) || (posY1<0)) {
							//this.wait(500);
							System.out.print("Paladin ha un muro di fronte a se'. ");
							changedir=1;
							posY1=posY1+1;
							//cambia direzione
							do {
								direction=(r.nextInt(4));
								//System.out.println(direction);
							} while (direction>2);
							if (direction == 0) { System.out.println("Si dirige a Est.");}
							if (direction == 1) { System.out.println("Si dirige a Nord.");}
							if (direction == 2) { System.out.println("Si dirige a Ovest.");}
							if (direction == 3) { System.out.println("Si dirige a Sud.");}
						}
					}
					
					//Aggiorno la posizione e i lifepoints del Goblin nell'arena
					goblinX1 = new Value(posX1);				
					goblinY1 = new Value(posY1);
					Value LPgoblin1 = new Value(lp);
					pos = new LogicTuple("Paladin",goblinX1,goblinY1,LPgoblin1);
					dungeon.out(arena, pos);
					
					//Stampo la posizione del Goblin nell'arena solo nel caso sia cambiata
					if (changedir==0 && lp>0) {
					System.out.println("Paladin e' in posizione: (" +goblinX1 +"," +goblinY1 +"). I suoi lifepoints residui sono " +LPgoblin1);
					}
					
					//Elimino la vecchia posizione dal centro di tuple
					dungeon.in(arena, pos1);
					
					Thread.sleep(50);
					
					//Leggo la posizione attuale degli altri personaggi
					//LogicTuple pos2 = new LogicTuple("Goblin_1", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					//LogicTuple pos1 = new LogicTuple("Goblin_1", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					//if (pos2==pos) {
						//System.out.println("Paladin e Goblin_1 sono in combattimento!");
						//}
						
					//Controllo che i lifepoints non siano 0 o inferiori, in tal caso il Goblin muore
					dungeon.rdp(arena, pos1);
					lp = pos1.getArg(2).intValue();
					//System.out.println(lp);
					if (lp<=0) {
						dead=1;
						dungeon.inp(arena, new LogicTuple ("Paladin", new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z")));
						LogicTuple end = new LogicTuple("Paladin is dead",goblinX1,goblinY1,new Value(0));
						dungeon.out(arena, end);
						}
				}
				
				LogicTuple b = new LogicTuple("All_dead", new alice.logictuple.Var("X"));
				try{
				dungeon.rdp(arena, b);
				out = b.getArg(0).intValue();
				}
				catch (Exception e){}
				//System.out.println(out);
				
			} while (dead==0 & out==0); //||
			
			if(dead==1){
			System.out.println("Paladin e' morto!!!");
			}
			//this.wait(2000);	
		} catch (Exception ex){}
	}
	
}