import java.awt.*;
import javax.swing.*;
import alice.logictuple.*;
import alice.tucson.api.*;
import java.lang.*;
import alice.tuprolog.*;
import java.io.*;

public class StartAll {	//apro il file StartG4.java
	public static void main(String[] args) throws Exception {	//apro il main
	
	//Importo le condizioni di controllo e coordinazione dal file respect
	//TextFileRead converti2=new TextFileRead();
	//String respectFile2=converti2.readTextFile("../respect/arena.rsp");
	
	//apro un contesto Tucson tucson di Default
	TucsonContext dungeon=Tucson.enterDefaultContext();

	//TupleCenter usato come mappa per passare i parametri e lo chiamo Hell	
	TupleCentreId hell = new TupleCentreId("hell");
	
	//TupleCenter usato per le posizioni e i combattimenti
	TupleCentreId arena = new TupleCentreId("arena");
	
	//setto le specifiche di Respect
	//dungeon.setSpec(arena, respectFile2);
	
	//Inizializzazione Agente Dungeon addetto alla costruzione della mappa
	//AgentId init = new AgentId("agente");
	//new Dungeon(init).spawn();
	
	//Inizializzazione Agente Goblin
	//AgentId monster1 = new AgentId("Goblin");
	//new Goblin(monster1).spawn();
	
	//Inizializzazione Agente Goblin con ritardo di passo a scelta
	AgentId monster1 = new AgentId("goblin");
	new Goblin(monster1, 1500).spawn();
	
	Thread.sleep(400);
	
	//Inizializzazione Agente Goblin con ritardo di passo a scelta
	//AgentId monster1 = new AgentId("goblin");
	//new Goblin(monster1, 100, 3, 16).spawn();
	
	//Inizializzazione Agente Troll
	//AgentId monster2 = new AgentId("Troll");
	//new Troll(monster2).spawn();
	
	//Inizializzazione Agente Troll con ritardo di passo a scelta
	AgentId monster2 = new AgentId("troll");
	new Troll(monster2, 1500).spawn();
	
	Thread.sleep(400);
	
	//Inizializzazione Agente Troll con ritardo di passo a scelta
	//AgentId monster2 = new AgentId("troll");
	//new Troll(monster2, 100, 16, 16).spawn();
	
	//Inizializzazione Agente Ranger
	//AgentId monster3 = new AgentId("Ranger");
	//new Ranger(monster3).spawn();
	
	//Inizializzazione Agente Ranger con ritardo di passo a scelta
	AgentId monster3 = new AgentId("ranger");
	new Ranger(monster3, 1500).spawn();
	
	Thread.sleep(400);
	
	//Inizializzazione Agente Ranger con ritardo di passo a scelta
	//AgentId monster3 = new AgentId("ranger");
	//new Ranger(monster3, 100, 3, 3).spawn();
	
	//Inizializzazione Agente Paladin
	//AgentId monster4 = new AgentId("Paladin");
	//new Paladin(monster4).spawn();
	
	//Inizializzazione Agente Paladin con ritardo di passo a scelta
	AgentId monster4 = new AgentId("paladin");
	new Paladin(monster4, 1500).spawn();
	
	//Thread.sleep(50);
	
	//Inizializzazione Agente Paladin con ritardo di passo a scelta
	//AgentId monster4 = new AgentId("paladin");
	//new Paladin(monster4, 100, 16, 3).spawn();
	
	}
}