import java.awt.*;
import javax.swing.*;
import alice.logictuple.*;
import alice.tucson.api.*;
import java.lang.*;
import alice.tuprolog.*;
import java.io.*;

public class War {	//apro il file War.java
	public static void main(String[] args) throws Exception {	//apro il main
	
	//Importo le condizioni di controllo e coordinazione dal file respect per il centro di tuple hell
	TextFileRead read=new TextFileRead();
	String respectHell=read.readTextFile("../respect/hell.rsp");
	
	//Importo le condizioni di controllo e coordinazione dal file respect per il centro di tuple arena
	TextFileRead read2=new TextFileRead();
	String respectArena=read2.readTextFile("../respect/arena.rsp");
	
	//System.out.println(respectFile);
	
	//apro un contesto Tucson tucson di Default
	TucsonContext dungeon=Tucson.enterDefaultContext();

	//TupleCenter usato come mappa per passare i parametri e lo chiamo Hell	
	TupleCentreId hell = new TupleCentreId("hell");
	
	//TupleCenter usato per le posizioni e i combattimenti
	TupleCentreId arena = new TupleCentreId("arena");
	
	//setto le specifiche di Respect
	dungeon.setSpec(hell, respectHell);
	
	//setto le specifiche di Respect
	dungeon.setSpec(arena, respectArena);
	
	//Inizializzazione Agente Dungeon addetto alla costruzione della mappa
	AgentId init = new AgentId("agente");
	new Dungeon(init).spawn();
	
	//Inizializzazione Agente Goblin 1
	//AgentId mostro1 = new AgentId("goblin1");
	//new Goblin1(mostro1).spawn();
	
	//Inizializzazione Agente Goblin 2
	//AgentId mostro2 = new AgentId("goblin2");
	//new Goblin2(mostro2).spawn();
	
	}
}